import { Component, h, Host, Prop } from '@stencil/core';
export class MadPaymentIcon {
  renderIcon() {
    switch (this.icon) {
      case 'american-express':
        return h("mad-payment-icon-amex", null);
      case 'discover':
        return h("mad-payment-icon-discover", null);
      case 'mastercard':
        return h("mad-payment-icon-mastercard", null);
      case 'visa':
        return h("mad-payment-icon-visa", null);
      case 'security-code':
        return h("mad-payment-icon-security-code", null);
      default:
        return h("div", null);
    }
  }
  render() {
    return (h(Host, null, this.renderIcon()));
  }
  static get is() { return "mad-payment-icon"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() { return {
    "$": ["card-icon.css"]
  }; }
  static get styleUrls() { return {
    "$": ["card-icon.css"]
  }; }
  static get properties() { return {
    "icon": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "CardTypes",
        "resolved": "\"american-express\" | \"diners-club\" | \"discover\" | \"jcb\" | \"maestro\" | \"mastercard\" | \"security-code\" | \"visa\"",
        "references": {
          "CardTypes": {
            "location": "import",
            "path": "../../model/CardTypes"
          }
        }
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": ""
      },
      "attribute": "icon",
      "reflect": false
    }
  }; }
}
