import { Component, Prop, h, Host, State, Event } from '@stencil/core';
export class MadPaymentCvvInput {
  constructor() {
    /**
     * Input placeholder text
     */
    this.placeholder = "";
    /**
     * Input name
     */
    this.name = "";
    this.value = "";
    this.type = "";
    this.max = 4;
  }
  handleChange(event) {
    event.preventDefault();
    const { target: { value } } = event;
    this.value = value;
    const updateEvent = {
      complete: value.length === this.max,
      value: value,
      valid: value.length === this.max
    };
    this.update.emit(updateEvent);
  }
  handleKeyPress(e) {
    if (isNaN(e.key) || e.key.trim() === '' || this.isMax()) {
      e.preventDefault();
    }
  }
  isMax() {
    const val = this.value ? this.value : '';
    return val.length === this.max;
  }
  render() {
    return (h(Host, null,
      h("mad-payment-input", { label: this.label, onPayKeyPress: ({ detail: e }) => { this.handleKeyPress(e); }, onPayInput: ({ detail: e }) => { this.handleChange(e); }, value: this.value, placeholder: this.placeholder },
        h("mad-payment-icon", { icon: "security-code", class: `card-icon visible`, slot: "icons" }))));
  }
  static get is() { return "mad-payment-cvv-input"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() { return {
    "$": ["cvv-input.css"]
  }; }
  static get styleUrls() { return {
    "$": ["cvv-input.css"]
  }; }
  static get properties() { return {
    "placeholder": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": "Input placeholder text"
      },
      "attribute": "placeholder",
      "reflect": false,
      "defaultValue": "\"\""
    },
    "label": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": true,
      "docs": {
        "tags": [],
        "text": "Label text is optional, if present label is dplayed"
      },
      "attribute": "label",
      "reflect": false
    },
    "name": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": "Input name"
      },
      "attribute": "name",
      "reflect": false,
      "defaultValue": "\"\""
    },
    "max": {
      "type": "number",
      "mutable": false,
      "complexType": {
        "original": "number",
        "resolved": "number",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": ""
      },
      "attribute": "max",
      "reflect": false,
      "defaultValue": "4"
    }
  }; }
  static get states() { return {
    "value": {},
    "type": {}
  }; }
  static get events() { return [{
      "method": "update",
      "name": "update",
      "bubbles": true,
      "cancelable": true,
      "composed": true,
      "docs": {
        "tags": [],
        "text": ""
      },
      "complexType": {
        "original": "PaymentElementUpdateEvent",
        "resolved": "{ valid: boolean; value: string; complete: boolean; errors?: InputError[]; }",
        "references": {
          "PaymentElementUpdateEvent": {
            "location": "import",
            "path": "../../model/PaymentElementUpdateEvent"
          }
        }
      }
    }]; }
}
