import { Component, Prop, h, Host, State } from '@stencil/core';
export class MadPaymentExpirationInput {
  constructor() {
    this.defaultMax = 4;
    /**
     * The max size of the input field
    */
    this.max = this.defaultMax;
  }
  handleChange(event) {
    const { target: { value } } = event;
    let val = value.replace(/\s+|[,\/]/g, "");
    ;
    if (val.length === 1 && val !== '1' && val !== '0') {
      this.value = `0${val} / `;
    }
    else if (val.length === 1 && val === '0') {
      this.value = '';
    }
    else if (val.length === 2) {
      this.value = `${val} / `;
    }
    else {
      this.value = value;
    }
  }
  handleKeyPress(e) {
    if (isNaN(e.key) || e.key.trim() === '' || this.isMax()) {
      e.preventDefault();
    }
  }
  isMax() {
    const val = this.value ? this.value.replace(/ \/ /g, '') : '';
    return val.length >= this.max;
  }
  render() {
    return (h(Host, null,
      h("mad-payment-input", { label: this.label, onPayKeyPress: ({ detail: e }) => { this.handleKeyPress(e); }, onPayInput: ({ detail: e }) => { this.handleChange(e); }, value: this.value, placeholder: this.placeholder })));
  }
  static get is() { return "mad-payment-expiration-input"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() { return {
    "$": ["expiration-input.css"]
  }; }
  static get styleUrls() { return {
    "$": ["expiration-input.css"]
  }; }
  static get properties() { return {
    "placeholder": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": "Input placeholder text"
      },
      "attribute": "placeholder",
      "reflect": false
    },
    "label": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": true,
      "docs": {
        "tags": [],
        "text": "Label text is optional, if present label is dplayed"
      },
      "attribute": "label",
      "reflect": false
    },
    "name": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": "Input name"
      },
      "attribute": "name",
      "reflect": false
    }
  }; }
  static get states() { return {
    "value": {},
    "max": {}
  }; }
}
