import { Component, Prop, h, Host, Event, Method, State } from '@stencil/core';
export class MadPaymentSelect {
  constructor() {
    this.selectOptionsFormatted = {};
  }
  async setOptions(options) {
    this.selectOptionsFormatted = options;
  }
  handleSelect(e) {
    const { target: { value } } = e;
    const updateEvent = {
      valid: value !== undefined,
      value: value,
      complete: value !== undefined
    };
    this.update.emit(updateEvent);
  }
  render() {
    return (h(Host, null,
      this.label && h("div", { class: "input-label" },
        h("label", { htmlFor: this.name }, this.label)),
      h("div", { class: "input-field" },
        h("select", { name: this.name, onInput: (e) => this.handleSelect(e) }, this.selectOptionsFormatted && Object.entries(this.selectOptionsFormatted).map(([key, value]) => {
          return h("option", { value: key, selected: value === key }, value);
        })))));
  }
  static get is() { return "mad-payment-select"; }
  static get encapsulation() { return "shadow"; }
  static get originalStyleUrls() { return {
    "$": ["select.css"]
  }; }
  static get styleUrls() { return {
    "$": ["select.css"]
  }; }
  static get properties() { return {
    "placeholder": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": "Input placeholder text"
      },
      "attribute": "placeholder",
      "reflect": false
    },
    "label": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": true,
      "docs": {
        "tags": [],
        "text": "Label text is optional, if present label is dplayed"
      },
      "attribute": "label",
      "reflect": false
    },
    "name": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": "Input name"
      },
      "attribute": "name",
      "reflect": false
    },
    "value": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": ""
      },
      "attribute": "value",
      "reflect": false
    },
    "max": {
      "type": "number",
      "mutable": false,
      "complexType": {
        "original": "number",
        "resolved": "number",
        "references": {}
      },
      "required": false,
      "optional": false,
      "docs": {
        "tags": [],
        "text": ""
      },
      "attribute": "max",
      "reflect": false
    },
    "selectOptions": {
      "type": "string",
      "mutable": false,
      "complexType": {
        "original": "string",
        "resolved": "string",
        "references": {}
      },
      "required": false,
      "optional": true,
      "docs": {
        "tags": [],
        "text": ""
      },
      "attribute": "select-options",
      "reflect": false
    }
  }; }
  static get states() { return {
    "selectOptionsFormatted": {}
  }; }
  static get events() { return [{
      "method": "update",
      "name": "update",
      "bubbles": true,
      "cancelable": true,
      "composed": true,
      "docs": {
        "tags": [],
        "text": ""
      },
      "complexType": {
        "original": "PaymentElementUpdateEvent",
        "resolved": "{ valid: boolean; value: string; complete: boolean; errors?: InputError[]; }",
        "references": {
          "PaymentElementUpdateEvent": {
            "location": "import",
            "path": "../../model/PaymentElementUpdateEvent"
          }
        }
      }
    }]; }
  static get methods() { return {
    "setOptions": {
      "complexType": {
        "signature": "(options: { [key: string]: string; }) => Promise<void>",
        "parameters": [{
            "tags": [],
            "text": ""
          }],
        "references": {
          "Promise": {
            "location": "global"
          }
        },
        "return": "Promise<void>"
      },
      "docs": {
        "text": "",
        "tags": []
      }
    }
  }; }
}
