import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import { d as defineCustomElement$5 } from './amex.js';
import { d as defineCustomElement$4 } from './discover.js';
import { d as defineCustomElement$3 } from './mastercard.js';
import { d as defineCustomElement$2 } from './security-code.js';
import { d as defineCustomElement$1 } from './visa.js';

const cardIconCss = ":host{width:auto}:host svg{width:100%;height:auto}";

const MadPaymentIcon = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
  }
  renderIcon() {
    switch (this.icon) {
      case 'american-express':
        return h("mad-payment-icon-amex", null);
      case 'discover':
        return h("mad-payment-icon-discover", null);
      case 'mastercard':
        return h("mad-payment-icon-mastercard", null);
      case 'visa':
        return h("mad-payment-icon-visa", null);
      case 'security-code':
        return h("mad-payment-icon-security-code", null);
      default:
        return h("div", null);
    }
  }
  render() {
    return (h(Host, null, this.renderIcon()));
  }
  static get style() { return cardIconCss; }
}, [1, "mad-payment-icon", {
    "icon": [1]
  }]);
function defineCustomElement() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["mad-payment-icon", "mad-payment-icon-amex", "mad-payment-icon-discover", "mad-payment-icon-mastercard", "mad-payment-icon-security-code", "mad-payment-icon-visa"];
  components.forEach(tagName => { switch (tagName) {
    case "mad-payment-icon":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, MadPaymentIcon);
      }
      break;
    case "mad-payment-icon-amex":
      if (!customElements.get(tagName)) {
        defineCustomElement$5();
      }
      break;
    case "mad-payment-icon-discover":
      if (!customElements.get(tagName)) {
        defineCustomElement$4();
      }
      break;
    case "mad-payment-icon-mastercard":
      if (!customElements.get(tagName)) {
        defineCustomElement$3();
      }
      break;
    case "mad-payment-icon-security-code":
      if (!customElements.get(tagName)) {
        defineCustomElement$2();
      }
      break;
    case "mad-payment-icon-visa":
      if (!customElements.get(tagName)) {
        defineCustomElement$1();
      }
      break;
  } });
}

export { MadPaymentIcon as M, defineCustomElement as d };
