import { proxyCustomElement, HTMLElement, h, Host } from '@stencil/core/internal/client';
import { d as defineCustomElement$1 } from './input.js';

const expirationInputCss = "";

const MadPaymentExpirationInput = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.defaultMax = 4;
    /**
     * The max size of the input field
    */
    this.max = this.defaultMax;
  }
  handleChange(event) {
    const { target: { value } } = event;
    let val = value.replace(/\s+|[,\/]/g, "");
    if (val.length === 1 && val !== '1' && val !== '0') {
      this.value = `0${val} / `;
    }
    else if (val.length === 1 && val === '0') {
      this.value = '';
    }
    else if (val.length === 2) {
      this.value = `${val} / `;
    }
    else {
      this.value = value;
    }
  }
  handleKeyPress(e) {
    if (isNaN(e.key) || e.key.trim() === '' || this.isMax()) {
      e.preventDefault();
    }
  }
  isMax() {
    const val = this.value ? this.value.replace(/ \/ /g, '') : '';
    return val.length >= this.max;
  }
  render() {
    return (h(Host, null, h("mad-payment-input", { label: this.label, onPayKeyPress: ({ detail: e }) => { this.handleKeyPress(e); }, onPayInput: ({ detail: e }) => { this.handleChange(e); }, value: this.value, placeholder: this.placeholder })));
  }
  static get style() { return expirationInputCss; }
}, [1, "mad-payment-expiration-input", {
    "placeholder": [1],
    "label": [1],
    "name": [1],
    "value": [32],
    "max": [32]
  }]);
function defineCustomElement() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["mad-payment-expiration-input", "mad-payment-input"];
  components.forEach(tagName => { switch (tagName) {
    case "mad-payment-expiration-input":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, MadPaymentExpirationInput);
      }
      break;
    case "mad-payment-input":
      if (!customElements.get(tagName)) {
        defineCustomElement$1();
      }
      break;
  } });
}

export { MadPaymentExpirationInput as M, defineCustomElement as d };
