import { proxyCustomElement, HTMLElement, createEvent, h, Host } from '@stencil/core/internal/client';

const selectCss = ":host{display:block;font-family:var(--font-sans-serif);font-size:var(--size-font-4);color:var(--color-font-default);margin-bottom:var(--spacing-x-small)}:host .input-field{display:block;width:auto;position:relative}:host .input-label{display:block;margin-bottom:var(--spacing-x-small)}:host .input-field select{display:block;font-size:var(--size-font-5);border:var(--size-border-small) solid var(--color-border-default);padding:var(--spacing-small);border-radius:var(--radius-border-medium);color:var(--color-font-default);transition:all ease-in 200ms;box-sizing:border-box;width:100%}:host .input-field select.error{border:var(--size-border-small) solid var(--color-border-brand)}:host .input-field input::placeholder{color:var(--color-font-light)}:host .input-field input:focus{border:var(--size-border-small) solid var(--color-border-active)}:host .input-field input:focus-visible{outline:var(--color-border-active) auto 1px}";

const MadPaymentSelect = /*@__PURE__*/ proxyCustomElement(class extends HTMLElement {
  constructor() {
    super();
    this.__registerHost();
    this.__attachShadow();
    this.update = createEvent(this, "update", 7);
    this.selectOptionsFormatted = {};
  }
  async setOptions(options) {
    this.selectOptionsFormatted = options;
  }
  handleSelect(e) {
    const { target: { value } } = e;
    const updateEvent = {
      valid: value !== undefined,
      value: value,
      complete: value !== undefined
    };
    this.update.emit(updateEvent);
  }
  render() {
    return (h(Host, null, this.label && h("div", { class: "input-label" }, h("label", { htmlFor: this.name }, this.label)), h("div", { class: "input-field" }, h("select", { name: this.name, onInput: (e) => this.handleSelect(e) }, this.selectOptionsFormatted && Object.entries(this.selectOptionsFormatted).map(([key, value]) => {
      return h("option", { value: key, selected: value === key }, value);
    })))));
  }
  static get style() { return selectCss; }
}, [1, "mad-payment-select", {
    "placeholder": [1],
    "label": [1],
    "name": [1],
    "value": [1],
    "max": [2],
    "selectOptions": [1, "select-options"],
    "selectOptionsFormatted": [32],
    "setOptions": [64]
  }]);
function defineCustomElement() {
  if (typeof customElements === "undefined") {
    return;
  }
  const components = ["mad-payment-select"];
  components.forEach(tagName => { switch (tagName) {
    case "mad-payment-select":
      if (!customElements.get(tagName)) {
        customElements.define(tagName, MadPaymentSelect);
      }
      break;
  } });
}

export { MadPaymentSelect as M, defineCustomElement as d };
