import { EventEmitter } from '../../stencil-public-runtime';
import { CardTypes } from '../../model/CardTypes';
import { CreditCardUpdate } from '../../model/CreditCardUpdate';
export declare class MadPaymentCardInput {
  cardTypes: Array<CardTypes>;
  baseCardTypes: Array<CardTypes>;
  defaultMax: number;
  /**
   * Input placeholder text
   */
  placeholder: string;
  /**
   * Label text is optional, if present label is dplayed
   */
  label?: string;
  /**
   * Input name
   */
  name: string;
  /**
   * The stateful value of the input field
   */
  value: string;
  /**
   * The possible card types based on the input
   */
  possibleCards: Array<CardTypes>;
  /**
   * The max size of the input field
  */
  max: number;
  /**
   * When value updated a CreditCardUpdate event will be published
   */
  update: EventEmitter<CreditCardUpdate>;
  handleChange(event: any): void;
  handleKeyPress(e: any): void;
  isMax(): boolean;
  prettyCardNumber(cardNumber: any, cardType: any): any;
  render(): any;
}
